unit MCKFlatTabControl;

//  file: MCKFlatTabControl.pas
//  file version: 0.1
//  last modified: 12.03.06
//  package: FlatControls
//  author: Karpinskyj Alexandr aka homm
//      mailto: homm86@mail.ru
//      My humble Web-Page: http://www.homm86.narod.ru

{$I KOLDEF.INC}

interface

uses    Windows,
        Messages,
        Classes,
        Controls,
        mirror,
        mckCtrls,
        KOL,
        Graphics,
        Forms,
        KOLFlatTabControl,
        SysUtils,
        mckObjs,
        dialogs,
        {$IFDEF _D6orHigher}                      
        DesignIntf,
        DesignEditors,
        DesignConst,   
        Variants                                  
        {$ELSE}                                   
        DsgnIntf
        {$ENDIF};

//{$R *.res}

type
    TKOLFlatTabControl = class (TKOLTabControl)
    private
        fDummyProperty: Integer;
        fTabHeight: Integer;
        fTabsFont: TKOLFont;
        fDefTabsFont: TKOLFont;
        fInTabsFont: Boolean;
        procedure SetFTC_TabsHeight(const Value: Integer);
        procedure SetFTC_TabsFont(const Value: TKOLFont);
    protected
        function SetupParams(const AName, AParent: String): String; Override;
        function AdditionalUnits: String; override;
        procedure SetupConstruct(SL: TStringList; const AName, AParent, Prefix: String); override;
        procedure SetupFirst(SL: TStringList; const AName, AParent, Prefix: String); override;
        function FontPropName: String; override;
    public
        constructor Create( AOwner: TComponent ); override;
        procedure Change; override;
        destructor Destroy; override;
    published
        property edgeType: Integer read fDummyProperty;
        property FTC_TabsHeight: Integer read fTabHeight write SetFTC_TabsHeight;
        property FTC_TabsFont: TKOLFont read fTabsFont write SetFTC_TabsFont;
    end;



procedure Register;

implementation

procedure Register;
begin
    RegisterComponents( 'KOL Additional', [TKOLFlatTabControl]);
end;


{ TKOLFlatTabControl }

function TKOLFlatTabControl.AdditionalUnits: String;
begin
    Result := ', KOLFlatTabControl';
end;

procedure TKOLFlatTabControl.Change;
var     isin: Boolean;
        AOpt: TTabControlOptions;
begin
    AOpt := Options;
    isin :=  tcoBottom in AOpt;
    exclude(AOpt, tcoBottom);
    if (WORD(AOpt)) > 0 then begin
        if isin then
            Options := [tcoBottom]
        else
            Options := [];
    end else
        inherited;
end;

constructor TKOLFlatTabControl.Create(AOwner: TComponent);
begin
    inherited;
    Options := [tcoBottom];
    fTabHeight := 22;
    fTabsFont := TKOLFont.Create(Self);
    fDefTabsFont := TKOLFont.Create(nil);
    fDefTabsFont.FontName := 'Verdana';
    fDefTabsFont.FontStyle := [fsBold];
    fDefTabsFont.FontHeight := 13;
    fTabsFont.Assign(fDefTabsFont);
end;

destructor TKOLFlatTabControl.Destroy;
begin
    fDefTabsFont.Free;
    fTabsFont.Free;
    inherited;
end;

function TKOLFlatTabControl.FontPropName: String;
begin
    if fInTabsFont then
        Result := 'FTC_TabsFont'
    else
        Result := 'Font';
end;

procedure TKOLFlatTabControl.SetFTC_TabsFont(const Value: TKOLFont);
begin
    fTabsFont.Assign( Value );
    Change;
end;

procedure TKOLFlatTabControl.SetFTC_TabsHeight(const Value: Integer);
begin
    fTabHeight := Value;
    Change;
end;

procedure TKOLFlatTabControl.SetupConstruct(SL: TStringList; const AName,
  AParent, Prefix: String);
begin
    SL.Add( Format('%s%s  :=  PFlatTabControl( NewFlatTabControl(%s)%s );',
                 [ Prefix, AName, SetupParams( AName, AParent ),
                   GenerateTransparentInits ] ) );
end;

procedure TKOLFlatTabControl.SetupFirst(SL: TStringList; const AName,
  AParent, Prefix: String);
begin
    inherited;
    if not (tcoBottom in Options) then
        SL.Add( Prefix + AName + '.FTC_Position := tpTop;');
    if fTabHeight <> 22 then
        SL.Add( Prefix + AName + '.FTC_TabsHeight := ' + inttostr(fTabHeight) + ';');

    fInTabsFont := TRUE;
    fTabsFont.GenerateCode(SL, AName, fDefTabsFont);
    fInTabsFont := FALSE;
end;

function TKOLFlatTabControl.SetupParams(const AName,
  AParent: String): String;
var IL, S: String;
    I: Integer;
begin
  asm
    jmp @@e_signature
    DB '#$signature$#', 0
    DB 'TKOLTabControl.SetupParams', 0
  @@e_signature:
  end;
  S := '';
  for I := 0 to Count - 1 do
  begin
    if S <> '' then
      S := S + ', ';
    S := S + StringConstant( 'Page' + IntToStr( I ) + 'Caption', Pages[ I ].Caption );
  end;
  IL := 'nil';
  if ImageList <> nil then
    IL := 'Result.' + ImageList.Name;
  Result := AParent + ', [ ' + S + ' ], ' + IL
            + ', ' + IntToStr( ImageList1stIdx );
end;

end.
